SystemOrganization addCategory: #'ChisCommit-Core'!
SystemOrganization addCategory: #'ChisCommit-Core-Tests'!

TestCase subclass: #CHCommitVisualizationTest
	instanceVariableNames: 'stamp commitVisual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHCommitVisualizationTest commentStamp: '<historical>' prior: 0!
A ROCommitVisualizationTest is a test class for testing the behavior of ROCommitVisualization!

!CHCommitVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	stamp := CHTimeStamp createFromString: 'AlejandroInfante 1/8/2013 16:52'.
	commitVisual := CHCommitVisualization create: stamp.! !

!CHCommitVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/18/2013 15:59'!
testConstruction

	self assert: (commitVisual model = stamp ).
	self assert: (commitVisual numberOfInteractions = 1 ).
	self assert: (commitVisual numberOfShapes = 2).
	self assert: ((commitVisual getInteraction: ROPopup) text = 'AlejandroInfante 1/8/2013 16:52' ).
	self assert: ((commitVisual shapes at:1) isShapedAs: ROCircle).! !

TestCase subclass: #CHMethodHistoryTest
	instanceVariableNames: 'class selector methodVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:35'!
setUp

	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	methodVersions := CHMethodHistory analyzeSelector: selector in: class.! !

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/7/2013 18:18'!
tearDown

	class removeFromSystem.! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/15/2013 15:57'!
testAsString

	self assert: (methodVersions methodName = methodVersions asString).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:35'!
testCommitTimeStamps
	
	self assert:  methodVersions commitTimeStamps size = 3.
	
	methodVersions := CHMethodHistory analyzeMethod: (class compiledMethodAt: selector).
	self assert: methodVersions commitTimeStamps size = 3.
	self assert: ((methodVersions commitTimeStamps first) = (class compiledMethodAt: selector)	timeStamp).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/15/2013 12:14'!
testLastCommit

	self assert:( methodVersions lastCommit = methodVersions commitTimeStamps first).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/15/2013 15:59'!
testMethodClass

	self assert: (methodVersions methodClass = 'ROVersioningTestClass').! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/15/2013 15:57'!
testMethodName

	self assert: (methodVersions methodName = selector asString).! !

TestCase subclass: #CHMethodVisualizationTest
	instanceVariableNames: 'methodHist methodVisual builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 16:04'!
setUp

	methodHist := CHMethodHistTest1 new.
	methodVisual := CHMethodVisualization create: methodHist.
	builder := CHVersionsBuilder new setUp: {CHMethodHistTest1 new}.
	builder setUpManagerClass: CHTestUtils getInstance getTestClassColorManager author: CHTestUtils getInstance getTestClassColorManager.! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 15:33'!
testConstruction

	self assert: (methodVisual model = methodHist).
	self assert: (methodVisual numberOfShapes = 2 ).
	self assert: (methodVisual numberOfInteractions = 0 ).
	self assert: ((methodVisual shapes at:1) isShapedAs: ROBox).
	self assert: ((methodVisual shapes at:1) color = Color veryLightGray).! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 09:17'!
testDrawCommits

	|commits|
	commits := methodHist commitTimeStamps.
	self assert:(methodVisual numberOfElements = 0).
	methodVisual drawCommits: (builder).
	self assert:(methodVisual numberOfElements = 3).! !

TestCase subclass: #CHTimeStampTest
	instanceVariableNames: 'parsedStamp method stamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHTimeStampTest commentStamp: '<historical>' prior: 0!
A ROTimeStampTest is a test class for testing the behavior of ROTimeStamp!

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 11:43'!
createMethod
	
	|class selector|
	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	^ (class compiledMethodAt: selector).	! !

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 12:10'!
createStamp

	^ (VersionsBrowser new 
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector) list first.! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:36'!
setUp

	method := self createMethod.
	stamp := self createStamp.
	parsedStamp := CHTimeStamp createFromString: stamp.
	
! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/8/2013 11:47'!
tearDown
	
	method methodClass removeFromSystem.! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:32'!
testAsString

	self assert: parsedStamp asString = method timeStamp .! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 11:48'!
testAuthor

	self assert: (parsedStamp author = method author ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 09:22'!
testDate

	self assert: (parsedStamp date = method timeStamp substrings second asDate ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:30'!
testEquals

	self assert:(parsedStamp = method timeStamp).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 17:23'!
testTime

	self assert: (parsedStamp time = method timeStamp substrings third asTime ).! !

TestCase subclass: #CHVersionVisualizationTest
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHVersionVisualizationTest commentStamp: '<historical>' prior: 0!
A ROVersionVisualizationTest is a test class for testing the behavior of ROVersionVisualization!

!CHVersionVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	visualization := CHVersionVisualization new.! !

!CHVersionVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/14/2013 10:35'!
testAddAllMethodHistory

	| collection |
	collection := OrderedCollection new.
	collection add: (CHMethodHistory analyzeSelector: #addMethodHistory: in: CHVersionVisualization).
	collection add: (CHMethodHistory analyzeSelector:#drawCommits in:CHVersionVisualization).

	self assert: visualization methodsHistory size = 0.	
	visualization addAllMethodHistory: collection.
	self assert: visualization methodsHistory size = 2.! !

!CHVersionVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:37'!
testAddMethodHistory

	| method1 method2 |
	method1 := CHMethodHistory analyzeSelector: #addMethodHistory: in: CHVersionVisualization.
	method2 := CHMethodHistory analyzeSelector:#drawCommits in:CHVersionVisualization.

	self assert: visualization methodsHistory size = 0.	
	visualization addMethodHistory: method1.
	self assert: visualization methodsHistory size = 1.
	visualization addMethodHistory: method2.
	self assert: visualization methodsHistory size = 2.! !

ROInteraction subclass: #CHInteraction
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

CHInteraction subclass: #CHChangeColorToAuthor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHChangeColorToAuthor methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:49'!
initializeElement: element

	element on: ROMouseClick do: [:event |
		|author commitsToChange|
		author := event element model author.
		commitsToChange := OrderedCollection new.
		controller methodsVisualization do: [ :eaMethod |
			commitsToChange addAll: (eaMethod elements select: [:eaCommit |
				eaCommit model author = author
				]).
		].
		commitsToChange do: #changeColor.
		].! !

CHInteraction subclass: #CHChangeColorToClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHChangeColorToClass methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:43'!
initializeElement: element

	element on: ROMouseClick do: [:event |
		|class methodsToChange|
		class := event element model methodClass.
		methodsToChange := controller methodsVisualization select: [ :eaMethod |
			eaMethod model methodClass = class
		].
		methodsToChange do: #changeColor.
		].! !

!CHInteraction class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:40'!
initializeWithController: aController
	
	^self new controller: aController.! !

!CHInteraction methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:40'!
controller: aController

	controller := aController.! !

ROElement subclass: #CHTimeStamp
	instanceVariableNames: 'author date time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHTimeStamp commentStamp: '<historical>' prior: 0!
This class encapsulate a TimeStamp generated by a commit, allowing to retrieve the information easily.!

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 12:00'!
createFromAuthor: author date: date time: time

	^ self new setAuthor: author date: date time: time.! !

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 11:59'!
createFromString: timeStamp

	| parts |
	parts := timeStamp substrings.
	^self createFromAuthor: parts first date: parts second time: parts third.! !

!CHTimeStamp methodsFor: 'comparing' stamp: 'AlejandroInfante 1/8/2013 12:32'!
= aStringOrStamp

	^ aStringOrStamp = self asString.! !

!CHTimeStamp methodsFor: 'converting' stamp: 'AlejandroInfante 1/9/2013 17:49'!
asString
	
	^ self author,' ',self date mmddyyyy,' ', time! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 15:59'!
author

	^author! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/8/2013 12:16'!
date

	^date.! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/10/2013 11:59'!
dateAndTime

	^ DateAndTime date: self date time: self time.! !

!CHTimeStamp methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/9/2013 17:49'!
setAuthor: newAuthor date: newDate time: newTime
	
	author:= newAuthor.
	date:= newDate asDate.
	time:= newTime.
	
	^self

	! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 17:48'!
time

	^time asTime.! !

ROElement subclass: #CHVersionElement
	instanceVariableNames: 'colorState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionElement commentStamp: '<historical>' prior: 0!
This is an abstract class that is the root of the visual elements displayed by Chisa, this class is a subclass from Roassals -> ROElement.!

CHVersionElement subclass: #CHCommitVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHCommitVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a commit, once instantiated it has everything it needs to displaying correctly.!

!CHCommitVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:45'!
defaultShape

	^ ROCircle new.! !

!CHCommitVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 15:34'!
model: aModel

	super model: aModel.
	self @ (ROPopup text: model asString ).! !

CHVersionElement subclass: #CHMethodVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a method, once instantiated it has everything it needs to displaying correctly, also is responsible about adding the commits on the visualization.!

!CHMethodVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:45'!
defaultShape

	^ ROBox new.! !

!CHMethodVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/15/2013 14:38'!
drawCommits: builder

	self addAll: (model commitTimeStamps collect: [:commit | 
			builder buildCommitVisualization: commit]).! !

!CHMethodVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 11:30'!
model: aModel

	super model: aModel.! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:50'!
create: model

	|elem|
	elem := (self new model: model) addShape: self defaultShape.
	^elem.! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 11:16'!
defaultShape

	^ self subclassResponsibility ! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 11:44'!
changeColor

	colorState changeColor.! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 11:32'!
color: aColor

	self shapes do: [:ea | ea color: aColor ].
	self view signalUpdate.! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 11:05'!
colorState: aColorState

	colorState := aColorState.! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 11:33'!
model: newModel

	super model: newModel.
	self removeInteraction: ROInteraction.
	self resizeStrategy: ROFixedSizedParent instance.
	
	^self.! !

Object subclass: #CHMethodHistory
	instanceVariableNames: 'method list changeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodHistory commentStamp: '<historical>' prior: 0!
This class encapsulate the all the versions of a method.!

CHMethodHistory subclass: #CHMethodHistTest1
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest1 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 17:30'!
commitTimeStamps
	^ (#('AlejandroInfante 3/5/2013 11:56' 'AlejandroInfante 3/4/2013 23:56' 'AlejandroInfante 3/4/2013 11:56') collect: [:each | CHTimeStamp createFromString: each])asOrderedCollection .! !

!CHMethodHistTest1 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 16:13'!
methodClass

	^'CHTestClass'.! !

CHMethodHistory subclass: #CHMethodHistTest2
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest2 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 11:57'!
commitTimeStamps
	^ (#('AlejandroInfante 3/6/2013 11:56' 'AlejandroInfante 3/4/2013 11:56' 'AlejandroInfante 3/2/2013 11:56') collect: [:each | CHTimeStamp createFromString: each]) asOrderedCollection .! !

!CHMethodHistTest2 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 11:10'!
methodClass

	^'CHTest2Class'.! !

CHMethodHistory subclass: #CHMethodHistTest3
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest3 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 17:13'!
commitTimeStamps
	^ (#('AlejandroInfante 3/5/2013 11:56' 'AlejandroInfante 3/4/2013 23:56' 'AlejandroInfante 3/4/2013 11:56') collect: [:each | CHTimeStamp createFromString: each])asOrderedCollection .! !

!CHMethodHistTest3 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 17:14'!
methodClass

	^'CHTest2Class'.! !

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 09:59'!
analyzeMethod:method

	 ^ self new analyzeMethod: method.! !

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:36'!
analyzeSelector: selector in: class

	^self analyzeMethod: (class compiledMethodAt: selector).! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 09:59'!
analyzeMethod: newMethod

	method := newMethod.
	self initializeList.
	^self.
	! !

!CHMethodHistory methodsFor: 'converting' stamp: 'AlejandroInfante 1/15/2013 15:57'!
asString

	^ self methodName! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/11/2013 10:04'!
commitTimeStamps

	^list copy.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 18:05'!
firstCommit

	^ self commitTimeStamps last.! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/9/2013 15:36'!
initializeList

	|changeSet|
	
	changeSet  := VersionsBrowser new
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector.

	list := changeSet list collect: [:elem | 
		CHTimeStamp createFromString: elem
		].
	changeList := changeSet changeList.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 18:06'!
lastCommit

	^ self commitTimeStamps first.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfanteTest 1/16/2013 14:58'!
methodClass

	"Probando con nuevos autores "
	^method methodClass asString.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/14/2013 09:33'!
methodName

	^method selector asString.! !

Object subclass: #CHTestUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

CHTestUtils class
	instanceVariableNames: 'instance'!

CHTestUtils class
	instanceVariableNames: 'instance'!

!CHTestUtils class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 10:44'!
getInstance

	instance isNil ifTrue:[instance := self new.].
	^instance.! !

!CHTestUtils methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 16:11'!
getTestClassColorManager

	^CHClassColorManager create: OrderedCollection new.! !

!CHTestUtils methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 11:18'!
getTestNormalizer

	| normalizer |
	normalizer := ROValueLinearNormalizer inContext: #(3539688960 3540034560).
	normalizer minScale: 0; maxScale: 800.
	^normalizer.! !

Object subclass: #CHVersionVisualization
	instanceVariableNames: 'view rawView elements labels methods builder ruler authorColorMan classColorMan classNames methodInteraction commitInteraction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionVisualization commentStamp: '<historical>' prior: 0!
This class instantiate the Roassal view and is responsible of adding the elements!

!CHVersionVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 17:04'!
analyzePackages: stringCollection

	^(self new analyzePackages: (stringCollection collect: [:ea | PackageInfo named: ea])) launch! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/14/2013 10:30'!
addAllMethodHistory: aCollection

	aCollection do: [:each | self addMethodHistory: each ]! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/10/2013 11:44'!
addMethodHistory: methodHistory

	methods add: methodHistory.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 17:06'!
analyzePackage: aPackageInfo

	|packClasses packMethods|
	packClasses := aPackageInfo classes.
	classNames addAll: (packClasses collect:#name).
	packMethods := OrderedCollection new.
	packClasses do: [:ea |
		packMethods addAll: ea methods
		].
	self addAllMethodHistory: (packMethods collect: [:ea | CHMethodHistory analyzeMethod: ea])! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 16:46'!
analyzePackages: aPackageCollection

	aPackageCollection do: [:each | self analyzePackage: each ]! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 15:42'!
drawCommits

	elements do: [:each | each drawCommits: builder].
	elements do: [:eaMethod | 
		eaMethod elements do: [:eaCommit |
			eaCommit @ (CHChangeColorToAuthor initializeWithController: self)
			]].! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/14/2013 10:04'!
drawLabels

	labels := OrderedCollection new.
	elements do: [:elem |
		|label|
		label := (ROLabel elementOn: elem model methodName).
		ROConstraint stick: label onTheRightOf: elem.
		labels add: label.
		].! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 15:42'!
drawMethods

	elements := methods collect: [:each | builder buildMethodVisualization: 
		each].
	elements do: [:ea | ea @ (CHChangeColorToClass initializeWithController: self)]! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 17:09'!
drawRuler

	ruler := builder buildTimeRuler.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/17/2013 16:20'!
initialize

	rawView := ROView new.
	view := ROMondrianViewBuilder view: rawView.
	methods := OrderedCollection new.
	elements := OrderedCollection new.
	builder := CHVersionsBuilder new.
	labels := OrderedCollection new.
	classNames := OrderedCollection new.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 18:09'!
launch
	
	self setClassNames.
	self setUp.
	self drawMethods.
	self drawCommits.
"	self drawRuler."
	(ROVerticalLineLayout new alignRight gapSize: 1) applyOn: (elements copy "add: ruler";yourself).

"	rawView add: ruler."
	rawView addAll: elements.
	rawView addAll: labels.
	ROEaselMorphic new populateMenuOn: view.
	view noLayout.
	rawView camera translateBy: -130 @ 0.
	view open.! !

!CHVersionVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/10/2013 11:45'!
methodsHistory

	^methods! !

!CHVersionVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 15:23'!
methodsVisualization

	^elements.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/18/2013 13:11'!
setClassNames

	classNames := (methods collect: #methodClass)! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/18/2013 15:01'!
setUp

	self setUpColorManagers.
	self setUpBuilder.
	builder setUp: methods.
	builder setUpManagerClass: classColorMan author: authorColorMan .! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/18/2013 15:02'!
setUpBuilder

	builder setUp: methods.
	builder setUpManagerClass: classColorMan author: authorColorMan.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/18/2013 14:46'!
setUpColorManagers

	|stamps|
	stamps := OrderedCollection new.
	classColorMan := CHClassColorManager create: classNames.
	methods do: [:ea | stamps addAll: ea commitTimeStamps].
	authorColorMan := CHAuthorColorManager create: (stamps collect: #author).! !

Object subclass: #CHVersionsBuilder
	instanceVariableNames: 'methodNormalizer classColorMan authorColorMan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder commentStamp: '<historical>' prior: 0!
This is a builder of CHVersionElements for an easy creation of a nice visualization.
!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/18/2013 14:39'!
buildCommitVisualization: stamp

	|elem|
	elem := CHCommitVisualization create: stamp.
	elem colorState: (authorColorMan getDefaultColorStateFor: elem ).
	elem size: 5.
	elem translateTo: (methodNormalizer roValue: stamp dateAndTime asSeconds ) @ elem positionAsInteger y.
	^ elem.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/18/2013 12:51'!
buildMethodVisualization: methodHist

	|elem posX |
	elem :=CHMethodVisualization create: methodHist.
	elem colorState: (classColorMan getDefaultColorStateFor: elem ).
	posX := (methodNormalizer roValue: methodHist firstCommit dateAndTime asSeconds).
	elem width: 800 - posX +25.
	elem height: 5.
	elem translateBy: ( posX @ elem position y).
	^elem. ! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/15/2013 15:32'!
buildTimeRuler

	^CHTimeRulerFactory new createTimeRuler: methodNormalizer.! !

!CHVersionsBuilder methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 15:38'!
normalizer

	^methodNormalizer.! !

!CHVersionsBuilder methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 15:38'!
normalizer: normalizer

	methodNormalizer := normalizer.! !

!CHVersionsBuilder methodsFor: 'setUp' stamp: 'AlejandroInfante 1/17/2013 15:43'!
setUp: aMethodHistCollection

	|commitCollection|
	commitCollection := OrderedCollection new.
	aMethodHistCollection do: [:each | commitCollection addAll: each commitTimeStamps].
	commitCollection := commitCollection collect: [:each | each dateAndTime asSeconds].
	methodNormalizer := ROValueLinearNormalizer inContext: commitCollection.
	methodNormalizer minScale: 0; maxScale: 800.! !

!CHVersionsBuilder methodsFor: 'setUp' stamp: 'AlejandroInfante 1/18/2013 12:50'!
setUpManagerClass: aClassMan author: aAuthorMan

	classColorMan := aClassMan.
	authorColorMan := aAuthorMan.! !
